%************************************************************************
% Author: Li, Annan, Copyright (C) 2018 Li, Annan. All rights reserved.
% This code is used in the following publications. If you find it useful, 
% please cite the paper.
% [1] Annan Li, Yunhong Wang, Jun Cheng and Jiang Liu. Combining 
% Multiple Deep Features for Glaucoma Classification, ICASSP 2018.
% [2] Annan Li, Jun Cheng, Damon Wing Kee Wong and Jiang Liu. Integrating 
% Holistic and Local Deep Features for Glaucoma Classification. EMBC 2016.
%*************************************************************************
function feature = extrctDeepFeat(image,net,param)

im_ = single(image);
im_ = imresize(im_, net.meta.normalization.imageSize(1:2));
im_ = bsxfun(@minus,im_,net.meta.normalization.averageImage);

if(param.isDAG==1)
    net.eval({'data',im_});
    output = net.vars(param.layer_idx).value;
    feature = output(:);
else
    % 'imagenet-caffe-alex','imagenet-vgg-verydeep-16','imagenet-vgg-verydeep-19'    
    res = vl_simplenn(net, im_);
    vec = res(param.layer_idx).x;
    feature = squeeze(vec);
end