%************************************************************************
% Author: Li, Annan, Copyright (C) 2018 Li, Annan. All rights reserved.
% This code is used in the following publications. If you find it useful, 
% please cite the paper.
% [1] Annan Li, Yunhong Wang, Jun Cheng and Jiang Liu. Combining 
% Multiple Deep Features for Glaucoma Classification, ICASSP 2018.
% [2] Annan Li, Jun Cheng, Damon Wing Kee Wong and Jiang Liu. Integrating 
% Holistic and Local Deep Features for Glaucoma Classification. EMBC 2016.
%*************************************************************************

%-------- setup matconvnet -----------
run('D:\matlab\vlfeat-0.9.20\toolbox\vl_setup.m');
run('D:\matlab\matconvnet-1.0-beta24\matlab\vl_setupnn.m');

net_dir = 'D:\data\matconvnet\';

%--------- set parameters ----------
netNameAll = {'imagenet-caffe-alex';'imagenet-vgg-verydeep-16';'imagenet-vgg-verydeep-19';...
    'imagenet-googlenet-dag';'imagenet-resnet-50-dag';...
    'imagenet-resnet-101-dag';'imagenet-resnet-152-dag'};
layerIdxAll = [17;33;39;152;174;344;514];
isDagAll = [0;0;0;1;1;1;1];

nNets = length(netNameAll);
ParamterAll = cell(nNets,1);
for i=1:nNets
    param.net_name = netNameAll{i};
    param.layer_idx = layerIdxAll(i);
    param.isDAG = isDagAll(i);
    ParamterAll{i} = param;
end



%--------- test feature extraction -----
image = imread('lena.jpg');

for i=1:nNets
    param = ParamterAll{i};
    net = load([net_dir,param.net_name,'.mat']);
    if(param.isDAG==1)
        net = dagnn.DagNN.loadobj(net);
        net.conserveMemory = 0;
    else
        net = vl_simplenn_tidy(net);
    end
    feature = extrctDeepFeat(image,net,param);
end


 